#!/usr/bin/perl

use strict;
use warnings;

use lib '/ts/packages';

use F5::ASMConfig::Server;
use F5::DbUtils;
use F5::Logger;

my $dbh = F5::DbUtils::get_dbh();
my $logger = F5::Logger->get_logger();

eval {
    my $server = F5::ASMConfig::Server->new(dbh => $dbh,
                                        logger => $logger);
    $server->start;
};

# Anything from here on should not be reached

if ($@) {
    $logger->error("ASM Config server died unexpectedly");
    $logger->error($@);
}
else {
    $logger->info("ASM Config server halted");
}
