#!/usr/bin/perl

   use strict;
   use warnings;

   use F5::Provisioning;
   use F5::Asmqkview;

   my $flg_add_request_log = $ENV{'ADD_REQUEST_LOG'} ? 1 : 0 ;
   my $request_log_size_limit = $ENV{'REQUEST_LOG_SIZE_LIMIT'} || 0 ;
   my $flg_include_traffic_data = $ENV{'INCLUDE_TRAFFIC_DATA'} ? 1 : 0 ;
   my $flg_no_policy_history = $ENV{'NO_POLICY_HISTORY'} ? 1 : 0 ;

   my $ASM_ENABLED = F5::Provisioning::is_module_enabled("asm");

   if ( !$ASM_ENABLED ){
     print "ASM is not provisioned.  Service command ignored.";
     exit 0
   } 

   F5::Asmqkview::run_asmqkview( flg_add_request_log => $flg_add_request_log,
                                 request_log_size_limit => $request_log_size_limit,
                                 flg_include_traffic_data => $flg_include_traffic_data,
                                 flg_no_policy_history => $flg_no_policy_history,
                                );
