#!/usr/bin/perl

use strict;
use F5::Logger;
use F5::DbUtils;
use F5::DbClean;

my $dbh = F5::DbUtils::get_dbh();
my $logger = F5::Logger->get_logger();

$logger->info("Starting clean_db");
my $db_clean = F5::DbClean->new(dbh => $dbh,
                                logger => $logger,
                                config_file => '/etc/ts/tools/clean_db.yaml');
my $error_trapped;
eval {
    $db_clean->run;
};

if ($@) {
    $error_trapped = $@;
}

# Should not get here
$logger->error("clean_db ended unexpectedly");
if ($error_trapped) {
    $logger->error($error_trapped);
}

