#!/usr/bin/perl
use strict;

#$Header$




# location of log files
my($logLocation)= '/ts/log';                      # path to TrafficShield log directory
my($arcLocation)= '/ts/log/archive';              # path to TrafficShield arcive directory


# check tool valid invoking
if ($#ARGV == 1) {
	print "Define new path for current log file and archive directory is: ".$ARGV[1]."\n";
	$logLocation = $ARGV[1];
	$arcLocation = $ARGV[1]."/archive";
	print "New log file location is: ".$logLocation."\n";
	print "New archive directory location is: ".$arcLocation."\n";
}
elsif ($#ARGV != 0) {
	print "./getlog fileName.log \n";
	exit;
}


# varibale declaration section
my($logFileName)=$ARGV[0];                        # log file name
my(@arcList);                                     # list of all tar files in arcive directory

my($cmd);                                         # run command
my($arcListTmp) = 'arcList.tmp';                  # list of /ts/log/arcive directory
my($lsArcDirCmd);                                 # list all tar-name files to file


# shell commands
my($catCmd)     = 'cat ';
my($rmCmd)      = 'rm ';
my($tarCmd)     = 'tar ';
my($mkdir)      = 'mkdir ';
my($echoCmd)    = 'echo ';
my($cpCmd)      = 'cp ';
my($lsCmd)      = 'ls -tr';

# list all arcive files names to the arcList.tmp
$lsArcDirCmd    = $lsCmd.' '.$arcLocation.'/*.tar.gz | '.$catCmd.' > '.$arcListTmp;
print $cmd  = $lsArcDirCmd."\n";
system($cmd);

# read and process all arcive-name  files
@arcList=();
my $i = 0;
my $val;
my $key;
open(INP, $arcListTmp) or die "Can not open $arcListTmp ($!)\n";
while(<INP>) {
	($val, $key)=split('\n',$_);
	$arcList[$i]=$val;
	$i++;

}
close(INP);

print "All tar name-files\n";
#debug printing
foreach my $tmp (@arcList){
	print $tmp."\n";
}

# create log file from the all log archive files
my $tmpLog='tmp.file';
my $i     = 0;
my $res   = 0;
foreach my $tarFileName (@arcList){
	my $openTar=$tarCmd."-x ".$logFileName." -zvf ";

	# open tar that located under arcive directory
	print $cmd=$openTar.$tarFileName."\n";
	$res = system($cmd);
	if ( $res != 0 ) {
		next;
	}

	# cat log file to log list file
	print $cmd=$catCmd.$logFileName." >> ".$tmpLog."\n";
	system($cmd);

	# tbd
	$i++;
	print $cmd=$echoCmd."log file number ".$i." added to ".$logFileName." >> ".$tmpLog."\n";
	system($cmd);


	# delete proceded file
	print $cmd=$rmCmd.$logFileName."\n";
	system($cmd);
}

# create log file with current running log file
print $cmd=$catCmd.$tmpLog." ".$logLocation."/".$logFileName." >> ".$logFileName."\n";
system($cmd);

# remove tmp log file
print $cmd=$rmCmd.$tmpLog."\n";
system($cmd);

# remove arcListTmp file
print $cmd=$rmCmd."-f ".$arcListTmp." \n";
system($cmd);






