#!/usr/bin/perl

use strict;
use warnings;


use F5::Syslog;
use File::Basename;

while(my $filename = shift) {
  my $available_space = get_available_space(dirname($filename));
  if (-s $filename > $available_space * 0.9) {
     F5::Syslog::ts_syslog( 'info', "%s", "ASM logrotate: file $filename will be truncated ...");
     truncate $filename, 0;
  }
}

exit 0;

#----------------------------------------------------------------------

sub get_available_space {
  my($dir) = @_;
  $ENV{PATH} = '/usr/bin:/bin';
  my $df_output = `df -k $dir`;
  chomp($df_output);
  $df_output =~ s/^.*\n//s;
  if ($df_output =~ /^\s/) {
    $df_output = "placeholder $df_output";
  }
  my($device, $total_size, $used_size, $available_space, $use_percent) = split(/\s+/, $df_output);
  return $available_space * 1024;
}
