#!/usr/bin/perl


use strict;
use warnings;

use F5::PolicyStabilityGraphs;
use F5::Db::Single;
use F5::Logger;

F5::Db::Single->init(die_on_instantiate_failure => 1);
my $logger = F5::Logger->new('/ts/log/policy_stability_graphs.log');
$logger->log_level('info');

$logger->info("Starting update of policy stability graphs");

my $policy_stability_graphs = F5::PolicyStabilityGraphs->new(logger => $logger);

eval {
    $policy_stability_graphs->update();
};


if ($@) {
    my $error_msg = "Policy stability graphs process ended unexpectedly: $@";
    $logger->error($error_msg);
    die $error_msg;
}

$logger->info("Finish update of policy stability graphs");

