#!/usr/bin/perl

use strict;
use warnings;

use Getopt::Long;

use F5::ASMConfig::ASMConfig;
use F5::PolicyValidator;
use F5::Logger;
use F5::DbUtils;

my $policy_id;
GetOptions('p|policy=i' => \$policy_id);

unless ($policy_id) {
  die "Missing policy id!\n";
}

my $dbh = F5::DbUtils::get_dbh();
my $logger = F5::Logger->new('/ts/log/policy_validator.log', 2);

my $validator = F5::PolicyValidator->new(dbh => $dbh,
					 logger => $logger);
print $validator->validate(policy_id => $policy_id);


