#!/usr/bin/perl -w
use strict;

use DBI;
use Date::Parse;
use Date::Manip;
use File::Copy;
use XML::Twig;
use File::Path;


require DBI;


#my $bvt_history_host = ";host=172.29.36.65";
my $bvt_history_host="";
my $user_auth_obj ={};
$user_auth_obj->{PRX_DATABASE}= "dbi:mysql:PRX$bvt_history_host;";
$user_auth_obj->{DCC_DATABASE}= "dbi:mysql:DCC$bvt_history_host;";
$user_auth_obj->{PLC_DATABASE}= "dbi:mysql:PLC$bvt_history_host;";
$user_auth_obj->{username} = 'root';
$user_auth_obj->{password} = '4Dm1n';

#my $addr = 'root@172.29.36.65:/';
my $addr='';
#my $dest_dir ='/home/levinlir/komodo/bin/generated_test';
#global vars


#my $support_id = '9670073671003144253';

if (@ARGV<1)
{
    usage();
}
if(3==@ARGV)
{
    $user_auth_obj->{username}=[1];
    $user_auth_obj->{password}=[2];
}

#set variables using use support id
my $support_id =$ARGV[0];
my $dest_dir = "/var/tmp/xml_tests/$support_id";
my $new_config ="$dest_dir/config.xml.cfg";
$user_auth_obj->{support_id} = $support_id ;



create_directory($dest_dir);

my $info = start_get_info_from_database($user_auth_obj);

print_variables_to_files($info,$dest_dir);

create_new_config_file_and_parse_certificates($info,$dest_dir,$new_config);

pack_file_in_tar();


#############################################################################
#Get information from database
#############################################################################
sub start_get_info_from_database
{
my ($user_auth_obj)=@_;
    
    

my $dbh = DBI->connect($user_auth_obj->{PRX_DATABASE},$user_auth_obj->{username},$user_auth_obj->{password}) or die 'cant connect';

#$sth->bind_columns(\$log_in_timestamp);
my $login_timestamp = return_value_from_db($dbh,"(select FROM_UNIXTIME(log_time) from PROXY_LOG where support_id=$user_auth_obj->{support_id});");

if ($login_timestamp eq  ""  )
{
    die "support id: $support_id does not exists";
}

my $info={};

$info->{login_date} = ParseDate($login_timestamp );

$info->{request}  =  return_value_from_db($dbh,"select request from PROXY_LOG where support_id=$user_auth_obj->{support_id};");

$info->{response} =  return_value_from_db($dbh,"select response from PROXY_LOG where support_id=$user_auth_obj->{support_id};");


print "login support_id :$login_timestamp \n";


#while($sth->fetch()) {
#   print $log_in_timestamp;
#}
$dbh->disconnect;
#FINISH DATABASE PRX

#GET info from DCC data base
$dbh = DBI->connect($user_auth_obj->{DCC_DATABASE},$user_auth_obj->{username},$user_auth_obj->{password});
die "can't connect" unless $dbh;



#query the login time for profile tamplete 1
$info->{login_template_1} = return_value_from_db($dbh, "(select modify_time FROM CONTENT_PROFILE_TEMPLATES order by modify_time desc  LIMIT 1);" );
print "template 1 login time :$info->{login_template_1} \n" if $info->{login_template_1}; 

#query the login time for profile tamplete 2
$info->{login_template_2} = return_value_from_db($dbh,"(select modify_time FROM CONTENT_PROFILE_TEMPLATES order by modify_time asc  LIMIT 1);");
print "template 2 login time :$info->{login_template_2} \n" if $info->{login_template_2}; 

my $oredering = find_correct_config_file($info->{login_template_1},$info->{login_template_2},$info->{login_date});

$info->{config_filename} = return_value_from_db($dbh,"(select defense_config_filename FROM CONTENT_PROFILE_TEMPLATES order by modify_time $oredering  LIMIT 1);");
print "config filename is: $info->{config_filename} \n" if $info->{config_filename};

$info->{request_xpath_filename}  = return_value_from_db($dbh,"(select request_xpath_filename FROM CONTENT_PROFILE_TEMPLATES order by modify_time $oredering  LIMIT 1);"); 
print "request xpath filename is: $info->{request_xpath_filename} \n" if $info->{request_xpath_filename};

$info->{response_xpath_filename}  = return_value_from_db($dbh,"(select response_xpath_filename FROM CONTENT_PROFILE_TEMPLATES order by modify_time $oredering  LIMIT 1);"); 
print "response xpath filename is: $info->{response_xpath_filename} \n" if $info->{response_xpath_filename};

$info->{schema_filename}  = return_value_from_db($dbh,"(select schema_filename FROM CONTENT_PROFILE_TEMPLATES order by modify_time $oredering  LIMIT 1);"); 
print "schema filename is: $info->{schema_filename} \n" if $info->{schema_filename};



$info->{profile_id} = return_value_from_db($dbh,"(select profile_id FROM CONTENT_PROFILE_TEMPLATES order by modify_time $oredering  LIMIT 1);"); 
print "xml profile id  is: $info->{profile_id} \n" if $info->{profile_id};

$dbh->disconnect;
#FINISH DATABASE DCC
#GET info from PLC data base
$dbh = DBI->connect($user_auth_obj->{PLC_DATABASE},$user_auth_obj->{username},$user_auth_obj->{password}) or die 'cant connect';

$info->{validation_file_name} = return_value_from_db($dbh,"select validation_file_name from  PL_XML_PROFILE_VALIDATION_FILES where profile_id=$info->{profile_id};");
print "validation_file_name: $info->{validation_file_name} \n" if $info->{validation_file_name};

$info->{validation_file_content} = return_value_from_db($dbh,"select validation_file_contents from  PL_XML_PROFILE_VALIDATION_FILES where profile_id=$info->{profile_id};");

$dbh->disconnect;
#END info from PLC data base 

return $info;

}




#############################################################################
#Create a new config file, and save the certificates from the old config file
#############################################################################
sub create_new_config_file_and_parse_certificates
{
   my ($info,$dest_dir,$new_config) = @_; 
   #use Twig to process the config file
    my $client_certificate_num=0;
    my $twig=XML::Twig->new(
           no_xxe => 1,
           twig_handlers =>
             { '/policy/profile/wss/client_credentials/client_data/key_file'  =>
              sub {
                    
                    $client_certificate_num++;
                    my $client_certificate_file_name = $_->first_child->text;
                    print "certificate filename: $client_certificate_file_name";
                    #copy client certificate
                    #system("cp   $addr:$client_certificate_file_name  $dest_dir/client_certificate$client_certificate_num")    ;
                    system("scp   $client_certificate_file_name  $dest_dir/client_certificate$client_certificate_num")    ;
                    $_->set_text("$dest_dir/client_certificate$client_certificate_num")
                    
                    
                   },
              '/policy/profile/wss/server_credentials/server_data/key_file' =>
              sub {
                    my $server_certificate_file_name = $_->first_child->text;
                    print "certificate filename: $server_certificate_file_name";
                    #copy client certificate
                    #system("cp   $addr:$server_certificate_file_name  $dest_dir/server_certificate")    ;
                    system("scp   $server_certificate_file_name  $dest_dir/server_certificate")    ;
                    $_->set_text("$dest_dir/server_certificate")
                      
                      
                    },
              pretty_print => 'indented', 
               
             },
                 
);

    
$twig->parsefile( "$dest_dir/config_file"); # build it
open my $outfh,">:utf8",$new_config or die "cannot open $new_config for writing: $!\n";
$twig->print(\*$outfh); 
}


###################################################################
#Print all the variables to files (config, xpath,schema file etc..)
###################################################################
sub print_variables_to_files
{
    my ($info,$dest_dir)=@_;
    
    system("scp   $addr$info->{config_filename}  $dest_dir/config_file")  if $info->{config_filename} ;
    system("scp   $addr$info->{request_xpath_filename}  $dest_dir/request_xpath") if $info->{request_xpath_filename} ;
    system("scp   $addr$info->{response_xpath_filename}  $dest_dir/response_xpath") if $info->{response_xpath_filename} ;
    system("scp   $addr$info->{schema_filename}  $dest_dir/schema.dat") if $info->{schema_filename} ;
    
    #create response request files
    print_variable_to_file("$dest_dir/response",$info->{response}) if $info->{response} ;
    print_variable_to_file("$dest_dir/request",$info->{request}) if $info->{request} ;
    print_variable_to_file("$dest_dir/wsdl.xml",$info->{validation_file_content}) if $info->{validation_file_content} ;
    
    
    open (REQUEST_FILE, "<$dest_dir/request") or print "can't read request file" && return;
    open (NEW_REQUEST_FILE, ">$dest_dir/new_req_v.xml") or print "can't write new request file" && return;
    my ($line,$start_writing_flag);
    $start_writing_flag = 0;
    foreach  $line (<REQUEST_FILE>)
    {
        if($line =~ (/^\s*$/))
        {
            $start_writing_flag = 1;
        }
        if($start_writing_flag)
        #start writing
        {
            print NEW_REQUEST_FILE $line;
        }
    }
    close(NEW_REQUEST_FILE);
    close(REQUEST_FILE);
    
    
}


#################################################
#Find correct config file that matches the policy
#################################################
sub find_correct_config_file
{
    my ($login_template_1,$login_template_2,$login_date) = @_;
    
    my $policy_date1 = ParseDate($login_template_1 );
    my $policy_date2 = ParseDate($login_template_2 );
    
    my $flag = Date_Cmp($login_date,$policy_date1);
    my $oredering ="";
    if($flag<1)
    {
        print "the login date is before the current xml policy\n";
        $flag = Date_Cmp($login_date,$policy_date2);
        if($flag<1)
        {
            print "the policy file for this id does not exists\n";
            die "cannot find policy file";
            
        }
        else
        {
            print "found policy file (last recent)\n";
            $oredering = "asc";
            
        }
        
    }
    else
    {
         print "found policy file (most recent)\n";
         $oredering = "desc";  
    }
    return $oredering;


}

#########################################################
#Return value from db (only works if 1 value is returend)
#########################################################
sub return_value_from_db
{
    my ($dbh,$user_query)= @_;
    my $sth =  $dbh->prepare($user_query);
    $sth->execute();
    my @temp_res  = $sth->fetch();
    $sth->finish();
    return $temp_res[0][0];
}

#########################################################
#print a variable to file
#########################################################
sub print_variable_to_file
{
    my($filename,$var);
    $filename= $_[0];
    $var     = $_[1];
    open(FILEHANDLE,">$filename");
    print FILEHANDLE $var;
    close(FILEHANDLE);
      
}

##########################################################
#Show the usage of the program
##########################################################
sub usage
{
    print "please use xml_support <support_id> \n";
    print "support_id      -- support id number \n";
    print ' the output dir will be \var\tmp\xml_test\<support_id> \n';
    print 'you can also use xml_support <support_id> <mySql username> <mySql password> \n';
    exit();
}


#########################################################
#Pack the files in tar
#########################################################
sub pack_file_in_tar
{
    system("tar -czf $dest_dir/$support_id.gz $dest_dir");
}

######################################################
#Create a directory
######################################################
sub create_directory
{
    my $new_dir = $_[0];
    if (-e $new_dir)
    {
        print "folder $new_dir exists\n";
    }
    else
    {
       mkpath ($new_dir,0777) or die "cannot create folder $new_dir\n"; 
    }
    
}
  

