#!/usr/bin/perl
use Time::HiRes;
use File::Copy;

our $logger;
BEGIN {
    $SIG{'__WARN__'} = sub { $logger->info(shift) if $logger };
}
close(STDOUT);
open(STDOUT, '>', '/dev/null');

eval {
    $logger = F5::Logger->new('/ts/log/cron.log');

    my @procs = qw(md monpd dcc bd bd_agent pabnagd);

    for my $proc (@procs) {
        my $glob_pattern = "/shared/core/${proc}.*.core{.gz,}";
        my ($corefile) = glob($glob_pattern); #core file with no pid
        if ($corefile) {
            my $new_filename = $corefile;
            my $time = time();
            $new_filename =~ s/\.core/\.core\.$time/;
            copy($corefile, $new_filename);
            #Make sure it is not changing right now
            Time::HiRes::sleep(0.5);
            if (-s $corefile == -s $new_filename) {
                unlink($corefile);
            }
            else {
                unlink($new_filename);
            }
        }
    }
};
if ($@) {
    $logger->error($@) if $logger;
}
