#!/usr/bin/perl

use strict;
use warnings;

use F5::ASMConfig::EasyClient;
use F5::BigipUtils;
use F5::Provisioning;
use F5::Logger;

exit unless F5::BigipUtils::is_device_bigip();
exit unless F5::Provisioning::is_asm_on();


our $logger;
BEGIN {
    $SIG{'__WARN__'} = sub { $logger->info(shift) if $logger };
}
close(STDOUT);
open(STDOUT, '>', '/dev/null');

eval {
    $logger = F5::Logger->new('/ts/log/cron.log');
    my $client = F5::ASMConfig::EasyClient->new(username => 'admin');
    my $session = $client->{session};

    my $call_flags = F5::ASMConfig::CallFlags->new(do_not_relay => 1,
                                                   singleton_process_lock_name => '/ts/lock/send_sync.lock',
                                                  );

    my $rv = $client->send_cluster_sync($session, $call_flags);
};
if ($@) {
    $logger->error($@) if $logger;
}
