#!/usr/bin/perl

use strict;
use warnings;

use F5::Logger;
use F5::Cluster::Sync;

my $logger = F5::Logger->get_logger(logger_name => 'clustering');

my $sync_dir = $ARGV[0] || '';
my $retval = 0;
eval {
    my $cluster_sync = F5::Cluster::Sync->new(dbh => F5::DbUtils::get_dbh(),
                                              logger => $logger);
    $retval = $cluster_sync->set_sync_file_dir(sync_dir => $sync_dir);
};
if ($@ || ! $retval) {
    $logger->error("Sync dir could not be set - $@");
    die "Could not set sync dir - $@\n";
}

exit;
