<?php
include_once $THRIFT_ROOT . '/packages/asmconfig/ASMConfig.php';

use Thrift\Transport\TSocket;
use Thrift\Transport\TBufferedTransport;
use Thrift\Protocol\TBinaryProtocol;
use Thrift\Protocol\TBinaryProtocolAccelerated;

class ASMConfigClientFull {

   protected $session_ = null;
   protected $client_ = null;
   protected $user_name_ = null;
   protected $gui_user_name_ = null;
   protected $extra_session_opts = null;

   public function __construct($user_name, $gui_user_name = "", $extra_session_opts = array() ) {
     $this->user_name_ = $user_name;
     $this->gui_user_name_ = $gui_user_name;
     $this->extra_session_opts_ = $extra_session_opts;
   }   

   public function open_connection_if_needed() {
     if (is_null($this->client_)) {
       $socket = new TSocket('localhost', 9781);
       $socket->setSendTimeout(3600000);
       $socket->setRecvTimeout(3600000);
       $transport = new TBufferedTransport($socket, 1024, 1024);
       $protocol = new TBinaryProtocol($transport);
       $this->client_ = new ASMConfigClient($protocol);
       $transport->open();

       $this->session_ = $this->client_->login($this->user_name_);
       $this->session_->gui_user_name = $this->gui_user_name_;
       $this->session_->default_rd = $this->extra_session_opts_["default_rd"];
       $this->session_->partition = $this->extra_session_opts_["partition"];
       $this->session_->client_ip_address = $this->extra_session_opts_["client_ip_address"];

     }
   }

   public function __call($method_call, $params) {
      $this->open_connection_if_needed();
      array_unshift($params, $this->session_);
      return call_user_func_array(array($this->client_, $method_call), $params);
   }

}

?>
