<?php

include_once $GLOBALS['THRIFT_ROOT'].'/Thrift.php';

include_once $GLOBALS['THRIFT_ROOT'].'/packages/asmconfig/f5_thrift.php';

function asmconfig_get_thrift_config($group, $key) {
  static $thrift_config = array();
  $THRIFT_CONFIG_BASE_DIR = '/usr/share/ts/share/asm_config';

  if (! isset($thrift_config[$group]) || ! isset($thrift_config[$group][$key])) {
    if (file_exists("${THRIFT_CONFIG_BASE_DIR}/${group}/${key}.json")) {
      if (! array_key_exists($group, $thrift_config)) {
        $thrift_config[$group] = array();
      }
      $thrift_config[$group][$key] = json_decode(file_get_contents("${THRIFT_CONFIG_BASE_DIR}/${group}/${key}.json"), true);
    }
  }

  if (isset($thrift_config[$group][$key])) {
    return $thrift_config[$group][$key];
  }
  return null;
}

//----------------------------------------------------------------------

class asmconfig_generic_object extends f5_thrift_object {

  public function get_prefix() {
    return 'asmconfig';
  }

  public function get_thrift_config($type, $item) {
    return asmconfig_get_thrift_config($type, $item);
  }
}

//----------------------------------------------------------------------

class asmconfig_generic_exception extends f5_thrift_exception {

  public function get_prefix() {
    return 'asmconfig';
  }

  public function get_thrift_config($type, $item) {
    return asmconfig_get_thrift_config($type, $item);
  }
}

//----------------------------------------------------------------------

class ASMConfigClient extends f5_thrift_client {
  public function get_prefix() {
    return 'asmconfig';
  }

  public function get_generic_object_class() {
    return "asmconfig_generic_object";
  }

  public function get_thrift_config($type, $item) {
    return asmconfig_get_thrift_config($type, $item);
  }
}

include_once $GLOBALS['THRIFT_ROOT'].'/packages/asmconfig/asmconfig_types.php';

?>
