#ifndef _attack_type_lookup
#define _attack_type_lookup

#include <string>

static inline unsigned int attack_type_lookup(const std::string &name)
{

    if (name == "Remote File Include") return 1;
    if (name == "Non-browser Client") return 2;
    if (name == "Other Application Attacks") return 3;
    if (name == "Trojan/Backdoor/Spyware") return 4;
    if (name == "Detection Evasion") return 5;
    if (name == "Vulnerability Scan") return 6;
    if (name == "Abuse of Functionality") return 7;
    if (name == "Authentication/Authorization Attacks") return 8;
    if (name == "Buffer Overflow") return 9;
    if (name == "Predictable Resource Location") return 10;
    if (name == "Information Leakage") return 11;
    if (name == "Directory Indexing") return 12;
    if (name == "Path Traversal") return 13;
    if (name == "XPath Injection") return 14;
    if (name == "LDAP Injection") return 15;
    if (name == "Server Side Code Injection") return 16;
    if (name == "Command Execution") return 17;
    if (name == "SQL-Injection") return 18;
    if (name == "Cross Site Scripting (XSS)") return 19;
    if (name == "Denial of Service") return 20;
    if (name == "Other Application Activity") return 21;
    if (name == "HTTP Parser Attack") return 22;
    if (name == "HTTP Request Smuggling Attack") return 23;
    if (name == "Forceful Browsing") return 25;
    if (name == "Brute Force Attack") return 27;
    if (name == "Injection Attempt") return 28;
    if (name == "Parameter Tampering") return 29;
    if (name == "XML Parser Attack") return 30;
    if (name == "Session Hijacking") return 31;
    if (name == "HTTP Response Splitting") return 32;
    if (name == "Web Scraping") return 33;
    if (name == "Malicious File Upload") return 34;
    if (name == "JSON Parser Attack") return 35;
    if (name == "Cross-site Request Forgery") return 36;
    if (name == "GWT Parser Attack") return 37;
    if (name == "WebSocket Parser Attack") return 38;
    if (name == "Cache Poisoning") return 39;
    if (name == "Server-Side Request Forgery (SSRF)") return 40;
    if (name == "XML External Entities (XXE)") return 41;
    if (name == "Insecure Deserialization") return 42;
    if (name == "NoSQL Injection") return 43;
    if (name == "Insecure File Upload") return 44;
    if (name == "Server-Side Template Injection") return 45;
    if (name == "GraphQL Parser Attack") return 46;
    if (name == "Protocol Buffers Parser Attack") return 47;
    return 0; // not found
}

#endif /* _attack_type_lookup */
