#ifndef _attack_type_str
#define _attack_type_str

#ifdef __cplusplus
extern "C" {
#endif

static inline const char *attack_type_str(unsigned int index)
{
    switch (index)
    {

        case 1: return "Remote File Include";
        case 2: return "Non-browser Client";
        case 3: return "Other Application Attacks";
        case 4: return "Trojan/Backdoor/Spyware";
        case 5: return "Detection Evasion";
        case 6: return "Vulnerability Scan";
        case 7: return "Abuse of Functionality";
        case 8: return "Authentication/Authorization Attacks";
        case 9: return "Buffer Overflow";
        case 10: return "Predictable Resource Location";
        case 11: return "Information Leakage";
        case 12: return "Directory Indexing";
        case 13: return "Path Traversal";
        case 14: return "XPath Injection";
        case 15: return "LDAP Injection";
        case 16: return "Server Side Code Injection";
        case 17: return "Command Execution";
        case 18: return "SQL-Injection";
        case 19: return "Cross Site Scripting (XSS)";
        case 20: return "Denial of Service";
        case 21: return "Other Application Activity";
        case 22: return "HTTP Parser Attack";
        case 23: return "HTTP Request Smuggling Attack";
        case 25: return "Forceful Browsing";
        case 27: return "Brute Force Attack";
        case 28: return "Injection Attempt";
        case 29: return "Parameter Tampering";
        case 30: return "XML Parser Attack";
        case 31: return "Session Hijacking";
        case 32: return "HTTP Response Splitting";
        case 33: return "Web Scraping";
        case 34: return "Malicious File Upload";
        case 35: return "JSON Parser Attack";
        case 36: return "Cross-site Request Forgery";
        case 37: return "GWT Parser Attack";
        case 38: return "WebSocket Parser Attack";
        case 39: return "Cache Poisoning";
        case 40: return "Server-Side Request Forgery (SSRF)";
        case 41: return "XML External Entities (XXE)";
        case 42: return "Insecure Deserialization";
        case 43: return "NoSQL Injection";
        case 44: return "Insecure File Upload";
        case 45: return "Server-Side Template Injection";
        case 46: return "GraphQL Parser Attack";
        case 47: return "Protocol Buffers Parser Attack";
        default: return "";
    }
}

#ifdef __cplusplus
}
#endif

#endif /* _attack_type_str */
