#ifndef _viol_index_description
#define _viol_index_description

#ifdef __cplusplus
extern "C" {
#endif

static inline const char *viol_index_description(unsigned int index)
{
    switch (index)
    {

        case 1: return "Illegal attachment in SOAP message";
        case 2: return "Data Guard: Information leakage detected";
        case 3: return "Login URL expired";
        case 4: return "Login URL bypassed";
        case 5: return "Request length exceeds defined buffer size";
        case 6: return "Virus detected";
        case 7: return "Evasion technique detected";
        case 8: return "Web Services Security failure";
        case 9: return "XML data does not comply with format settings";
        case 10: return "XML data does not comply with schema or WSDL document";
        case 11: return "Malformed XML data";
        case 12: return "CSRF attack detected";
        case 13: return "Failed to convert character";
        case 14: return "HTTP protocol compliance failed";
        case 15: return "Access from disallowed Geolocation";
        case 16: return "Illegal query string length";
        case 17: return "Illegal request length";
        case 18: return "Illegal cookie length";
        case 19: return "Illegal URL length";
        case 20: return "CSRF authentication expired";
        case 22: return "Brute Force: Maximum login attempts are exceeded";
        case 23: return "SOAP method not allowed";
        case 24: return "Illegal meta character in value";
        case 25: return "Illegal meta character in parameter name";
        case 26: return "Illegal meta character in URL";
        case 27: return "Illegal repeated parameter name";
        case 28: return "JSON data does not comply with format settings";
        case 29: return "Illegal header length";
        case 30: return "Null in multi-part parameter value";
        case 31: return "Illegal POST data length";
        case 32: return "Illegal empty parameter value";
        case 33: return "Illegal parameter";
        case 34: return "Illegal query string or POST data";
        case 35: return "Illegal session ID in URL";
        case 36: return "Illegal method";
        case 37: return "Illegal flow to URL";
        case 38: return "Illegal URL";
        case 39: return "Illegal file type";
        case 40: return "Parameter value does not comply with regular expression";
        case 41: return "Illegal number of mandatory parameters";
        case 42: return "Attack signature detected";
        case 43: return "Illegal parameter numeric value";
        case 44: return "Illegal parameter data type";
        case 45: return "Illegal parameter value length";
        case 46: return "Illegal dynamic parameter value";
        case 47: return "Illegal static parameter value";
        case 48: return "Expired timestamp";
        case 49: return "ASM Cookie Hijacking";
        case 50: return "Access from disallowed User/Session/IP/Device ID";
        case 51: return "Illegal entry point";
        case 52: return "Malformed JSON data";
        case 53: return "Cookie not RFC-compliant";
        case 54: return "Modified domain cookie(s)";
        case 55: return "Modified ASM cookie";
        case 56: return "Illegal HTTP status in response";
        case 57: return "Illegal request content type";
        case 58: return "Illegal meta character in header";
        case 59: return "Malformed GWT data";
        case 60: return "Disallowed file upload content detected";
        case 61: return "Access from malicious IP address";
        case 62: return "Illegal Base64 value";
        case 63: return "GWT data does not comply with format settings";
        case 64: return "Mandatory HTTP header is missing";
        case 65: return "Illegal redirection attempt";
        case 66: return "Bad WebSocket handshake request";
        case 67: return "Failure in WebSocket framing protocol";
        case 68: return "Mask not found in client frame";
        case 69: return "Illegal WebSocket frame length";
        case 70: return "Null character found in WebSocket text message";
        case 71: return "Illegal cross-origin request";
        case 72: return "Text content found in binary only WebSocket";
        case 73: return "Binary content found in text only WebSocket";
        case 74: return "Illegal WebSocket extension";
        case 75: return "Illegal number of frames per message";
        case 76: return "Illegal WebSocket binary message length";
        case 77: return "Plain text data does not comply with format settings";
        case 78: return "IP is blacklisted";
        case 79: return "Threat Campaign detected";
        case 80: return "Illegal parameter array value";
        case 81: return "JSON data does not comply with JSON schema";
        case 82: return "Mandatory parameter is missing";
        case 83: return "Illegal parameter location";
        case 84: return "Bad Actor Detected";
        case 85: return "Blocking Condition Detected";
        case 86: return "Mitigation action determined by Threat Analysis Platform";
        case 87: return "Leaked Credentials Detection";
        case 88: return "Illegal host name";
        case 89: return "Host name mismatch";
        case 90: return "Bad Actor Convicted";
        case 91: return "Mandatory request body is missing";
        case 92: return "Illegal repeated header";
        case 93: return "Violation Rating Threat detected";
        case 94: return "Violation Rating Need Examination detected";
        case 95: return "DataSafe Data Integrity";
        case 96: return "Disallowed file upload content detected in body";
        case 97: return "Server-side access to disallowed host";
        case 98: return "Malformed GraphQL data";
        case 99: return "GraphQL data does not comply with format settings";
        case 121: return "GraphQL introspection query";
        case 122: return "Bot Client Detected";
        case 123: return "Malformed gRPC data";
        case 124: return "gRPC data does not comply with format settings";
        case 125: return "Illegal gRPC method";
        case 126: return "Unsupported browser";
        default: return "";
    }
}

#ifdef __cplusplus
}
#endif

#endif /* _viol_index_description */
