<?php
define('VIOL_XML_SOAP_ATTACHMENT', 1);
define('VIOL_DATA_GUARD', 2);
define('VIOL_LOGIN_URL_EXPIRED', 3);
define('VIOL_LOGIN_URL_BYPASSED', 4);
define('VIOL_REQUEST_MAX_LENGTH', 5);
define('VIOL_VIRUS', 6);
define('VIOL_EVASION', 7);
define('VIOL_XML_WEB_SERVICES_SECURITY', 8);
define('VIOL_XML_FORMAT', 9);
define('VIOL_XML_SCHEMA', 10);
define('VIOL_XML_MALFORMED', 11);
define('VIOL_CSRF', 12);
define('VIOL_ENCODING', 13);
define('VIOL_HTTP_PROTOCOL', 14);
define('VIOL_GEOLOCATION', 15);
define('VIOL_QUERY_STRING_LENGTH', 16);
define('VIOL_REQUEST_LENGTH', 17);
define('VIOL_COOKIE_LENGTH', 18);
define('VIOL_URL_LENGTH', 19);
define('VIOL_CSRF_EXPIRED', 20);
define('VIOL_BRUTE_FORCE', 22);
define('VIOL_XML_SOAP_METHOD', 23);
define('VIOL_PARAMETER_VALUE_METACHAR', 24);
define('VIOL_PARAMETER_NAME_METACHAR', 25);
define('VIOL_URL_METACHAR', 26);
define('VIOL_PARAMETER_REPEATED', 27);
define('VIOL_JSON_FORMAT', 28);
define('VIOL_HEADER_LENGTH', 29);
define('VIOL_PARAMETER_MULTIPART_NULL_VALUE', 30);
define('VIOL_POST_DATA_LENGTH', 31);
define('VIOL_PARAMETER_EMPTY_VALUE', 32);
define('VIOL_PARAMETER', 33);
define('VIOL_FLOW_DISALLOWED_INPUT', 34);
define('VIOL_DYNAMIC_SESSION', 35);
define('VIOL_METHOD', 36);
define('VIOL_FLOW', 37);
define('VIOL_URL', 38);
define('VIOL_FILETYPE', 39);
define('VIOL_PARAMETER_VALUE_REGEXP', 40);
define('VIOL_FLOW_MANDATORY_PARAMS', 41);
define('VIOL_ATTACK_SIGNATURE', 42);
define('VIOL_PARAMETER_NUMERIC_VALUE', 43);
define('VIOL_PARAMETER_DATA_TYPE', 44);
define('VIOL_PARAMETER_VALUE_LENGTH', 45);
define('VIOL_PARAMETER_DYNAMIC_VALUE', 46);
define('VIOL_PARAMETER_STATIC_VALUE', 47);
define('VIOL_COOKIE_EXPIRED', 48);
define('VIOL_ASM_COOKIE_HIJACKING', 49);
define('VIOL_SESSION_AWARENESS', 50);
define('VIOL_FLOW_ENTRY_POINT', 51);
define('VIOL_JSON_MALFORMED', 52);
define('VIOL_COOKIE_MALFORMED', 53);
define('VIOL_COOKIE_MODIFIED', 54);
define('VIOL_ASM_COOKIE_MODIFIED', 55);
define('VIOL_HTTP_RESPONSE_STATUS', 56);
define('VIOL_URL_CONTENT_TYPE', 57);
define('VIOL_HEADER_METACHAR', 58);
define('VIOL_GWT_MALFORMED', 59);
define('VIOL_FILE_UPLOAD', 60);
define('VIOL_MALICIOUS_IP', 61);
define('VIOL_PARAMETER_VALUE_BASE64', 62);
define('VIOL_GWT_FORMAT', 63);
define('VIOL_MANDATORY_HEADER', 64);
define('VIOL_REDIRECT', 65);
define('VIOL_WEBSOCKET_BAD_REQUEST', 66);
define('VIOL_WEBSOCKET_FRAMING_PROTOCOL', 67);
define('VIOL_WEBSOCKET_FRAME_MASKING', 68);
define('VIOL_WEBSOCKET_FRAME_LENGTH', 69);
define('VIOL_WEBSOCKET_TEXT_NULL_VALUE', 70);
define('VIOL_CROSS_ORIGIN_REQUEST', 71);
define('VIOL_WEBSOCKET_TEXT_MESSAGE_NOT_ALLOWED', 72);
define('VIOL_WEBSOCKET_BINARY_MESSAGE_NOT_ALLOWED', 73);
define('VIOL_WEBSOCKET_EXTENSION', 74);
define('VIOL_WEBSOCKET_FRAMES_PER_MESSAGE_COUNT', 75);
define('VIOL_WEBSOCKET_BINARY_MESSAGE_LENGTH', 76);
define('VIOL_PLAINTEXT_FORMAT', 77);
define('VIOL_BLACKLISTED_IP', 78);
define('VIOL_THREAT_CAMPAIGN', 79);
define('VIOL_PARAMETER_ARRAY_VALUE', 80);
define('VIOL_JSON_SCHEMA', 81);
define('VIOL_MANDATORY_PARAMETER', 82);
define('VIOL_PARAMETER_LOCATION', 83);
define('VIOL_MALICIOUS_DEVICE', 84);
define('VIOL_BLOCKING_CONDITION', 85);
define('VIOL_THREAT_ANALYSIS', 86);
define('VIOL_LEAKED_CREDENTIALS', 87);
define('VIOL_HOSTNAME', 88);
define('VIOL_HOSTNAME_MISMATCH', 89);
define('VIOL_CONVICTION', 90);
define('VIOL_MANDATORY_REQUEST_BODY', 91);
define('VIOL_HEADER_REPEATED', 92);
define('VIOL_RATING_THREAT', 93);
define('VIOL_RATING_NEED_EXAMINATION', 94);
define('VIOL_DATA_INTEGRITY', 95);
define('VIOL_FILE_UPLOAD_IN_BODY', 96);
define('VIOL_SERVER_SIDE_HOST', 97);
define('VIOL_GRAPHQL_MALFORMED', 98);
define('VIOL_GRAPHQL_FORMAT', 99);
define('VIOL_GRAPHQL_INTROSPECTION_QUERY', 121);
define('VIOL_BOT_CLIENT', 122);
define('VIOL_GRPC_MALFORMED', 123);
define('VIOL_GRPC_FORMAT', 124);
define('VIOL_GRPC_METHOD', 125);
define('VIOL_BROWSER', 126);

define('MIN_USER_VIOL_INDEX', 100);
define('MAX_USER_VIOL_INDEX', 120);

$VIOL_ARRAY = array(
  VIOL_ASM_COOKIE_HIJACKING => 'ASM Cookie Hijacking',
  VIOL_GEOLOCATION => 'Access from disallowed Geolocation',
  VIOL_SESSION_AWARENESS => 'Access from disallowed User/Session/IP/Device ID',
  VIOL_MALICIOUS_IP => 'Access from malicious IP address',
  VIOL_ATTACK_SIGNATURE => 'Attack signature detected',
  VIOL_CONVICTION => 'Bad Actor Convicted',
  VIOL_MALICIOUS_DEVICE => 'Bad Actor Detected',
  VIOL_WEBSOCKET_BAD_REQUEST => 'Bad WebSocket handshake request',
  VIOL_WEBSOCKET_BINARY_MESSAGE_NOT_ALLOWED => 'Binary content found in text only WebSocket',
  VIOL_BLOCKING_CONDITION => 'Blocking Condition Detected',
  VIOL_BOT_CLIENT => 'Bot Client Detected',
  VIOL_BRUTE_FORCE => 'Brute Force: Maximum login attempts are exceeded',
  VIOL_CSRF => 'CSRF attack detected',
  VIOL_CSRF_EXPIRED => 'CSRF authentication expired',
  VIOL_COOKIE_MALFORMED => 'Cookie not RFC-compliant',
  VIOL_DATA_GUARD => 'Data Guard: Information leakage detected',
  VIOL_DATA_INTEGRITY => 'DataSafe Data Integrity',
  VIOL_FILE_UPLOAD => 'Disallowed file upload content detected',
  VIOL_FILE_UPLOAD_IN_BODY => 'Disallowed file upload content detected in body',
  VIOL_EVASION => 'Evasion technique detected',
  VIOL_COOKIE_EXPIRED => 'Expired timestamp',
  VIOL_ENCODING => 'Failed to convert character',
  VIOL_WEBSOCKET_FRAMING_PROTOCOL => 'Failure in WebSocket framing protocol',
  VIOL_GWT_FORMAT => 'GWT data does not comply with format settings',
  VIOL_GRAPHQL_FORMAT => 'GraphQL data does not comply with format settings',
  VIOL_GRAPHQL_INTROSPECTION_QUERY => 'GraphQL introspection query',
  VIOL_HTTP_PROTOCOL => 'HTTP protocol compliance failed',
  VIOL_HOSTNAME_MISMATCH => 'Host name mismatch',
  VIOL_BLACKLISTED_IP => 'IP is blacklisted',
  VIOL_PARAMETER_VALUE_BASE64 => 'Illegal Base64 value',
  VIOL_HTTP_RESPONSE_STATUS => 'Illegal HTTP status in response',
  VIOL_POST_DATA_LENGTH => 'Illegal POST data length',
  VIOL_URL => 'Illegal URL',
  VIOL_URL_LENGTH => 'Illegal URL length',
  VIOL_WEBSOCKET_BINARY_MESSAGE_LENGTH => 'Illegal WebSocket binary message length',
  VIOL_WEBSOCKET_EXTENSION => 'Illegal WebSocket extension',
  VIOL_WEBSOCKET_FRAME_LENGTH => 'Illegal WebSocket frame length',
  VIOL_XML_SOAP_ATTACHMENT => 'Illegal attachment in SOAP message',
  VIOL_COOKIE_LENGTH => 'Illegal cookie length',
  VIOL_CROSS_ORIGIN_REQUEST => 'Illegal cross-origin request',
  VIOL_PARAMETER_DYNAMIC_VALUE => 'Illegal dynamic parameter value',
  VIOL_PARAMETER_EMPTY_VALUE => 'Illegal empty parameter value',
  VIOL_FLOW_ENTRY_POINT => 'Illegal entry point',
  VIOL_FILETYPE => 'Illegal file type',
  VIOL_FLOW => 'Illegal flow to URL',
  VIOL_GRPC_METHOD => 'Illegal gRPC method',
  VIOL_HEADER_LENGTH => 'Illegal header length',
  VIOL_HOSTNAME => 'Illegal host name',
  VIOL_URL_METACHAR => 'Illegal meta character in URL',
  VIOL_HEADER_METACHAR => 'Illegal meta character in header',
  VIOL_PARAMETER_NAME_METACHAR => 'Illegal meta character in parameter name',
  VIOL_PARAMETER_VALUE_METACHAR => 'Illegal meta character in value',
  VIOL_METHOD => 'Illegal method',
  VIOL_WEBSOCKET_FRAMES_PER_MESSAGE_COUNT => 'Illegal number of frames per message',
  VIOL_FLOW_MANDATORY_PARAMS => 'Illegal number of mandatory parameters',
  VIOL_PARAMETER => 'Illegal parameter',
  VIOL_PARAMETER_ARRAY_VALUE => 'Illegal parameter array value',
  VIOL_PARAMETER_DATA_TYPE => 'Illegal parameter data type',
  VIOL_PARAMETER_LOCATION => 'Illegal parameter location',
  VIOL_PARAMETER_NUMERIC_VALUE => 'Illegal parameter numeric value',
  VIOL_PARAMETER_VALUE_LENGTH => 'Illegal parameter value length',
  VIOL_QUERY_STRING_LENGTH => 'Illegal query string length',
  VIOL_FLOW_DISALLOWED_INPUT => 'Illegal query string or POST data',
  VIOL_REDIRECT => 'Illegal redirection attempt',
  VIOL_HEADER_REPEATED => 'Illegal repeated header',
  VIOL_PARAMETER_REPEATED => 'Illegal repeated parameter name',
  VIOL_URL_CONTENT_TYPE => 'Illegal request content type',
  VIOL_REQUEST_LENGTH => 'Illegal request length',
  VIOL_DYNAMIC_SESSION => 'Illegal session ID in URL',
  VIOL_PARAMETER_STATIC_VALUE => 'Illegal static parameter value',
  VIOL_JSON_SCHEMA => 'JSON data does not comply with JSON schema',
  VIOL_JSON_FORMAT => 'JSON data does not comply with format settings',
  VIOL_LEAKED_CREDENTIALS => 'Leaked Credentials Detection',
  VIOL_LOGIN_URL_BYPASSED => 'Login URL bypassed',
  VIOL_LOGIN_URL_EXPIRED => 'Login URL expired',
  VIOL_GWT_MALFORMED => 'Malformed GWT data',
  VIOL_GRAPHQL_MALFORMED => 'Malformed GraphQL data',
  VIOL_JSON_MALFORMED => 'Malformed JSON data',
  VIOL_XML_MALFORMED => 'Malformed XML data',
  VIOL_GRPC_MALFORMED => 'Malformed gRPC data',
  VIOL_MANDATORY_HEADER => 'Mandatory HTTP header is missing',
  VIOL_MANDATORY_PARAMETER => 'Mandatory parameter is missing',
  VIOL_MANDATORY_REQUEST_BODY => 'Mandatory request body is missing',
  VIOL_WEBSOCKET_FRAME_MASKING => 'Mask not found in client frame',
  VIOL_THREAT_ANALYSIS => 'Mitigation action determined by Threat Analysis Platform',
  VIOL_ASM_COOKIE_MODIFIED => 'Modified ASM cookie',
  VIOL_COOKIE_MODIFIED => 'Modified domain cookie(s)',
  VIOL_WEBSOCKET_TEXT_NULL_VALUE => 'Null character found in WebSocket text message',
  VIOL_PARAMETER_MULTIPART_NULL_VALUE => 'Null in multi-part parameter value',
  VIOL_PARAMETER_VALUE_REGEXP => 'Parameter value does not comply with regular expression',
  VIOL_PLAINTEXT_FORMAT => 'Plain text data does not comply with format settings',
  VIOL_REQUEST_MAX_LENGTH => 'Request length exceeds defined buffer size',
  VIOL_XML_SOAP_METHOD => 'SOAP method not allowed',
  VIOL_SERVER_SIDE_HOST => 'Server-side access to disallowed host',
  VIOL_WEBSOCKET_TEXT_MESSAGE_NOT_ALLOWED => 'Text content found in binary only WebSocket',
  VIOL_THREAT_CAMPAIGN => 'Threat Campaign detected',
  VIOL_BROWSER => 'Unsupported browser',
  VIOL_RATING_NEED_EXAMINATION => 'Violation Rating Need Examination detected',
  VIOL_RATING_THREAT => 'Violation Rating Threat detected',
  VIOL_VIRUS => 'Virus detected',
  VIOL_XML_WEB_SERVICES_SECURITY => 'Web Services Security failure',
  VIOL_XML_FORMAT => 'XML data does not comply with format settings',
  VIOL_XML_SCHEMA => 'XML data does not comply with schema or WSDL document',
  VIOL_GRPC_FORMAT => 'gRPC data does not comply with format settings',
);

$SEVERITIES_ARRAY = array(
  1 => 'Alert',
  2 => 'Critical',
  0 => 'Emergency',
  3 => 'Error',
  6 => 'Informational',
  5 => 'Notice',
  4 => 'Warning',
);

$VIOLATION_TYPES_ARRAY = array(
  2 => 'Access Violation',
  5 => 'Cookie Violation',
  4 => 'Input Violation',
  3 => 'Length Violation',
  6 => 'Negative Security Violation',
  1 => 'RFC Violation',
  0 => 'Unspecified',
);
?>