package F5::DataProtection;

use strict;
use warnings;
use MIME::Base64;
use Digest::MD5;

require DynaLoader;

our @ISA = qw(DynaLoader);

our $VERSION = '0.1';

bootstrap F5::DataProtection $VERSION;

# Preloaded methods go here.
#======================================================================

sub generate_key {
    my ($seed, @params) = @_;
    if ($seed) {
        #Hash seed and force to 16 bytes
        $seed = Digest::MD5::md5_base64($seed);
        return  MIME::Base64::encode_base64(F5::DataProtection::XS::data_protect_seed_key(pack("A16", $seed), @params), '');
    }
    else {
        return  MIME::Base64::encode_base64(F5::DataProtection::XS::data_protect_gen_key(@_), '');
    }
}

#======================================================================

1;

__END__
# Below is the pod documentation for the DataProtection Module

=head1 NAME

F5::DataProtection - Perl extension for accessing the DataProtection encryption library

=head1 SYNOPSIS

use F5::DataProtection;

my $key = F5::DataProtection::generate_key()

=head1 DESCRIPTION

This module wraps the Data Protection library for Perl usage.

=head1 EXPORT

None by default.

=head1 AUTHOR

Avri Balofsky, E<lt>a.balofsky@f5.comE<gt>

=head1 SEE ALSO

L<perl>.

=cut
